###################
# Pin Constraints #
###################


# I2C Chain on FMC-HDMI-CAM
set_property PACKAGE_PIN B7 [get_ports fmc_hdmi_cam_iic_scl_io]
#set_property PULLUP true [get_ports fmc_hdmi_cam_iic_scl_io]
set_property SLEW SLOW [get_ports fmc_hdmi_cam_iic_scl_io]
set_property DRIVE 8 [get_ports fmc_hdmi_cam_iic_scl_io]
set_property PACKAGE_PIN B6 [get_ports fmc_hdmi_cam_iic_sda_io]
#set_property PULLUP true [get_ports fmc_hdmi_cam_iic_sda_io]
set_property SLEW SLOW [get_ports fmc_hdmi_cam_iic_sda_io]
set_property DRIVE 8 [get_ports fmc_hdmi_cam_iic_sda_io]
set_property PACKAGE_PIN C3 [get_ports {fmc_hdmi_cam_iic_rst_b[0]}]
set_property SLEW SLOW [get_ports {fmc_hdmi_cam_iic_rst_b[0]}]
set_property DRIVE 8 [get_ports {fmc_hdmi_cam_iic_rst_b[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports fmc_hdmi_cam_iic_*]

# HDMI Input (ADV7611) on FMC-HDMI-CAM
set_property PACKAGE_PIN L5 [get_ports fmc_hdmii_clk]
set_property PACKAGE_PIN P2 [get_ports fmc_hdmii_spdif]
set_property PACKAGE_PIN K8 [get_ports {fmc_hdmii_data[0]}]
set_property PACKAGE_PIN J8 [get_ports {fmc_hdmii_data[1]}]
set_property PACKAGE_PIN N5 [get_ports {fmc_hdmii_data[2]}]
set_property PACKAGE_PIN N6 [get_ports {fmc_hdmii_data[3]}]
set_property PACKAGE_PIN J6 [get_ports {fmc_hdmii_data[4]}]
set_property PACKAGE_PIN J7 [get_ports {fmc_hdmii_data[5]}]
set_property PACKAGE_PIN P5 [get_ports {fmc_hdmii_data[6]}]
set_property PACKAGE_PIN P6 [get_ports {fmc_hdmii_data[7]}]
set_property PACKAGE_PIN M6 [get_ports {fmc_hdmii_data[8]}]
set_property PACKAGE_PIN L6 [get_ports {fmc_hdmii_data[9]}]
set_property PACKAGE_PIN R4 [get_ports {fmc_hdmii_data[10]}]
set_property PACKAGE_PIN R2 [get_ports {fmc_hdmii_data[11]}]
set_property PACKAGE_PIN P1 [get_ports {fmc_hdmii_data[12]}]
set_property PACKAGE_PIN R5 [get_ports {fmc_hdmii_data[13]}]
set_property PACKAGE_PIN R3 [get_ports {fmc_hdmii_data[14]}]
set_property PACKAGE_PIN N1 [get_ports {fmc_hdmii_data[15]}]
set_property IOSTANDARD LVCMOS18 [get_ports fmc_hdmii_*]
set_property IOB TRUE [get_ports fmc_hdmii_*]

# HDMI Output (ADV7511) on FMC-HDMI-CAM
set_property PACKAGE_PIN L4 [get_ports fmc_hdmio_clk]
set_property PACKAGE_PIN M1 [get_ports {fmc_hdmio_data[0]}]
set_property PACKAGE_PIN M2 [get_ports {fmc_hdmio_data[1]}]
set_property PACKAGE_PIN R7 [get_ports {fmc_hdmio_data[2]}]
set_property PACKAGE_PIN N3 [get_ports {fmc_hdmio_data[3]}]
set_property PACKAGE_PIN P7 [get_ports {fmc_hdmio_data[4]}]
set_property PACKAGE_PIN L1 [get_ports {fmc_hdmio_data[5]}]
set_property PACKAGE_PIN U1 [get_ports {fmc_hdmio_data[6]}]
set_property PACKAGE_PIN N4 [get_ports {fmc_hdmio_data[7]}]
set_property PACKAGE_PIN L2 [get_ports {fmc_hdmio_data[8]}]
set_property PACKAGE_PIN J1 [get_ports {fmc_hdmio_data[9]}]
set_property PACKAGE_PIN U2 [get_ports {fmc_hdmio_data[10]}]
set_property PACKAGE_PIN T1 [get_ports {fmc_hdmio_data[11]}]
set_property PACKAGE_PIN J2 [get_ports {fmc_hdmio_data[12]}]
set_property PACKAGE_PIN K2 [get_ports {fmc_hdmio_data[13]}]
set_property PACKAGE_PIN T2 [get_ports {fmc_hdmio_data[14]}]
set_property PACKAGE_PIN J3 [get_ports {fmc_hdmio_data[15]}]
set_property IOSTANDARD LVCMOS18 [get_ports fmc_hdmio_*]
set_property IOB TRUE [get_ports fmc_hdmio_*]

# Camera interface (PYTHON-1300) on FMC-HDMI-CAM
set_property PACKAGE_PIN A5 [get_ports IO_PYTHON_CAM_clk_pll]
set_property PACKAGE_PIN C4 [get_ports IO_PYTHON_CAM_reset_n]
set_property PACKAGE_PIN A4 [get_ports {IO_PYTHON_CAM_trigger[2]}]
set_property PACKAGE_PIN G8 [get_ports {IO_PYTHON_CAM_trigger[1]}]
set_property PACKAGE_PIN G7 [get_ports {IO_PYTHON_CAM_trigger[0]}]
set_property PACKAGE_PIN A7 [get_ports {IO_PYTHON_CAM_monitor[0]}]
set_property PACKAGE_PIN A6 [get_ports {IO_PYTHON_CAM_monitor[1]}]
set_property PACKAGE_PIN F7 [get_ports IO_PYTHON_SPI_spi_sclk]
set_property PACKAGE_PIN E7 [get_ports IO_PYTHON_SPI_spi_ssel_n]
set_property PACKAGE_PIN D7 [get_ports IO_PYTHON_SPI_spi_mosi]
set_property PACKAGE_PIN D6 [get_ports IO_PYTHON_SPI_spi_miso]
set_property PACKAGE_PIN B4 [get_ports IO_PYTHON_CAM_clk_out_p]; #CAM_CLK_P
set_property PACKAGE_PIN B3 [get_ports IO_PYTHON_CAM_clk_out_n]; #CAM_CLK_N
set_property PACKAGE_PIN E2 [get_ports IO_PYTHON_CAM_sync_p]; #CAM_SYNC_P
set_property PACKAGE_PIN D2 [get_ports IO_PYTHON_CAM_sync_n]; #CAM_SYNC_N
#set_property PACKAGE_PIN A2 [get_ports {IO_PYTHON_CAM_data_p[]}]; #CAM_DATA7_P
#set_property PACKAGE_PIN A1 [get_ports {IO_PYTHON_CAM_data_n[]}]; #CAM_DATA7_N
#set_property PACKAGE_PIN D1 [get_ports {IO_PYTHON_CAM_data_p[]}]; #CAM_DATA6_P
#set_property PACKAGE_PIN C1 [get_ports {IO_PYTHON_CAM_data_n[]}]; #CAM_DATA6_N
set_property PACKAGE_PIN C6 [get_ports {IO_PYTHON_CAM_data_p[3]}]; #CAM_DATA5_P
set_property PACKAGE_PIN C5 [get_ports {IO_PYTHON_CAM_data_n[3]}]; #CAM_DATA5_N
set_property PACKAGE_PIN E8 [get_ports {IO_PYTHON_CAM_data_p[2]}]; #CAM_DATA4_P
set_property PACKAGE_PIN D8 [get_ports {IO_PYTHON_CAM_data_n[2]}]; #CAM_DATA4_N
set_property PACKAGE_PIN B2 [get_ports {IO_PYTHON_CAM_data_p[1]}]; #CAM_DATA3_P
set_property PACKAGE_PIN B1 [get_ports {IO_PYTHON_CAM_data_n[1]}]; #CAM_DATA3_N
set_property PACKAGE_PIN H1 [get_ports {IO_PYTHON_CAM_data_p[0]}]; #CAM_DATA2_P
set_property PACKAGE_PIN G1 [get_ports {IO_PYTHON_CAM_data_n[0]}]; #CAM_DATA2_N
#set_property PACKAGE_PIN G6 [get_ports {IO_PYTHON_CAM_data_p[]}]; #CAM_DATA1_P
#set_property PACKAGE_PIN F6 [get_ports {IO_PYTHON_CAM_data_n[]}]; #CAM_DATA1_N
#set_property PACKAGE_PIN E4 [get_ports {IO_PYTHON_CAM_data_p[]}]; #CAM_DATA0_P
#set_property PACKAGE_PIN E3 [get_ports {IO_PYTHON_CAM_data_n[]}]; #CAM_DATA0_N

set_property IOSTANDARD LVCMOS18 [get_ports IO_PYTHON_CAM_clk_pll]
set_property IOSTANDARD LVCMOS18 [get_ports IO_PYTHON_CAM_reset_n]
set_property IOSTANDARD LVCMOS18 [get_ports IO_PYTHON_CAM_trigger*]
set_property IOSTANDARD LVCMOS18 [get_ports IO_PYTHON_CAM_monitor*]
set_property IOSTANDARD LVCMOS18 [get_ports IO_PYTHON_SPI_spi_*]

set_property IOSTANDARD LVDS [get_ports IO_PYTHON_CAM_clk_out_*]
set_property IOSTANDARD LVDS [get_ports IO_PYTHON_CAM_sync_*]
set_property IOSTANDARD LVDS [get_ports IO_PYTHON_CAM_data_*]

set_property DIFF_TERM true [get_ports IO_PYTHON_CAM_clk_out_*]
set_property DIFF_TERM true [get_ports IO_PYTHON_CAM_sync_*]
set_property DIFF_TERM true [get_ports IO_PYTHON_CAM_data_*]


