# load project
source scripts/create_project.tcl

# reset runs
reset_run impl_1
reset_run synth_1

# run synthesis
launch_runs synth_1
wait_on_run synth_1

# runs implementation
launch_runs impl_1 -to_step write_bitstream
wait_on_run impl_1

# export hardware description and bitstream
file mkdir $project_dir/$design_name.sdk
file copy -force $project_dir/$design_name.runs/impl_1/${design_name}_wrapper.sysdef $project_dir/$design_name.sdk/${design_name}_wrapper.hdf

# close project
close_project

# copy bitstream to software/boot directory
file copy -force $project_dir/$design_name.runs/impl_1/${design_name}_wrapper.bit ../../software/boot/${design_name}_wrapper.bit

# generate BOOT.bin
if {[file exists ../../software/boot/${design_name}.bif]} {
	cd ../../software/boot
	puts "Generating BOOT.BIN..."
	exec >@stdout 2>@stderr bootgen -image ${design_name}.bif -w -o BOOT.bin
	cd ../../hardware/vivado
}

