


# source sdsoc platform generation script
source -notrace C:/Xilinx/SDSoC/2015.4/scripts/vivado/sdsoc_pfm.tcl

# create hardware platform description
set pfm [sdsoc::create_pfm ${::design_name}_hw.pfm]
sdsoc::pfm_name $pfm "avnet.com" "xd" "${::design_name}" "1.0"
sdsoc::pfm_description $pfm "FMC-HDMI-CAM + PYTHON-1300-C, 2015.4"

# define clock ports
sdsoc::pfm_clock $pfm clk_out2 clk_wiz_1 0 true proc_sys_reset_clk150

# define AXI ports
sdsoc::pfm_axi_port $pfm M_AXI_GP1 processing_system7_1 M_AXI_GP
sdsoc::pfm_axi_port $pfm S_AXI_HP2 processing_system7_1 S_AXI_HP

# define interrupt ports
for {set i 9} {$i < 16} {incr i} {
   sdsoc::pfm_irq $pfm In$i interrupts
}

# generate hardware platform
sdsoc::generate_hw_pfm $pfm

# save and archive design
save_bd_design
archive_project ${::design_name}.zip -force -exclude_run_results
